
package app.crossword.yourealwaysbe.forkyzscanner.settings

import androidx.datastore.core.CorruptionException
import androidx.datastore.core.Serializer
import com.google.protobuf.InvalidProtocolBufferException

import java.io.InputStream
import java.io.OutputStream

object SettingsSerializer : Serializer<Settings> {
    override val defaultValue : Settings = Settings.newBuilder()
        .setDynamicColors(true)
        .build()

    override suspend fun readFrom(input : InputStream) : Settings {
        try {
            return Settings.parseFrom(input)
        } catch (exception : InvalidProtocolBufferException) {
            throw CorruptionException("Cannot read proto.", exception)
        }
    }

    override suspend fun writeTo(t : Settings, output : OutputStream) =
        t.writeTo(output)
}
